<template>
  <div
    class="w-full"
    @click="
      authenticated
        ? handleGameEntryOpenWindow(gameForDisplay, 550, 850)
        : toggleLoginRegisterDialog()
    "
  >
    <div
      class="border-[1px] rounded-[5px] border-[var(--background3)] relative"
    >
      <img
        v-lazy="gameForDisplay.GameIconUrl"
        class="object-contain h-[25vw] w-full rounded-t-[5px] align-middle max-w-full"
      />
      <div
        class="bg-background3 text-[var(--text)] text-[10px] flex justify-center items-center w-full h-[25px]"
      >
        {{ gameForDisplay.GameNameForDisplay }}
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, PropType, computed } from "vue";
import { IGameBsi } from "@/models/bsiGameList";
import { store } from "@/store";
import { handleGameEntryOpenWindow } from "@/composables/useTheme";
import SportDisplayModel from "@/components/sport/sportDisplayModel";

export default defineComponent({
  name: "HorizontalGameEntryComponent",
  props: {
    game: {
      type: Object as PropType<IGameBsi>,
      required: true,
    },
  },
  setup(props) {
    const gameForDisplay = computed(() => new SportDisplayModel(props.game));
    const authenticated = computed(() => store.state.auth);
    const { toggleLoginRegisterDialog } = commonHelper;
    return {
      gameForDisplay,
      authenticated,
      handleGameEntryOpenWindow,
      toggleLoginRegisterDialog,
    };
  },
});
</script>

<style scoped lang="scss">
.box-entry {
  height: 421px;
  position: relative;
  border-radius: 10px;
  box-sizing: border-box;
  border: 1px solid #393c68;
  width: 100%;
  overflow: hidden;
  cursor: pointer;

  .footer-entry {
    height: 100px;
    width: 100%;
    position: absolute;
    z-index: 1;
    bottom: 0;
    left: 0;
    color: var(--text5);

    .background-play-game {
      background-color: #393c68;
      opacity: 0.8;
      width: 100%;
      height: 100%;
      position: absolute;
      z-index: 0;
    }

    .game-name {
      height: 50px;
      display: block;
      font-family: sans-serif;
      line-height: 40px;
      margin: 0;
      text-overflow: ellipsis;
      white-space: nowrap;
      font-size: 16px;
      text-align: center;
    }

    .btn-play-game {
      background: #ff4e00;
      border: 1px solid #ff4e00;
      border-radius: 25px;
      font-size: 16px;
      font-weight: 700;
      padding: 5px 20px;
      width: 100%;

      &:hover,
      &:focus {
        background: #009fe3;
        border-color: #009fe3;
        color: black;
      }
    }
  }
}
</style>
